#include <Adafruit_GFX.h>
#include <stdint.h>
#include <TFTv2.h>
#include <SPI.h>
#include <SeeedTouchScreen.h>
#include <Event.h>
#include <Timer.h>




#define LEFT2RIGHT 0
#define DOWN2UP    1
#define RIGHT2LEFT 2
#define UP2DOWN    3
//#define pinMode (trig,OUTPUT);
Timer t;

int tid=1000;
int stepspeed=1000;
int steplenght=10;
boolean stepdirection=LOW;

char buf[12];

int dirpin = 9;
int steppin = 10;
const int trig = 11;
int interrupt_pin = 12;

int eventid;

bool runok = false;

#define YP A2   // must be an analog pin, use "An" notation!
#define XM A1   // must be an analog pin, use "An" notation!
#define YM 14   // can be a digital pin, this is A0
#define XP 17   // can be a digital pin, this is A3 

#define MINPRESSURE 10
#define MAXPRESSURE 1000

TouchScreen ts = TouchScreen(XP, YP, XM, YM);


   
void setup()
{
  Serial.begin(9600);
  pinMode(trig, OUTPUT);    //initialise trigger pin
  digitalWrite(trig, LOW);  //ensure trigger is turned off


  /*  Draw Boxes - Demonstrate drawRectangle and fillRectangle
    fillScreen(INT16U XL,INT16U XR,INT16U YU,INT16U YD,INT16U color);
    fillRectangle(INT16U poX, INT16U poY, INT16U length, INT16U width, INT16U color);
    drawRectangle(INT16U poX, INT16U poY, INT16U length,INT16U width,INT16U color);
*/
/*  draw text's APP
    drawChar(INT8U ascii,INT16U poX, INT16U poY,INT16U size, INT16U fgcolor);
    drawString(char *string,INT16U poX, INT16U poY,INT16U size,INT16U fgcolor);
*/
    TFT_BL_ON;      // turn on the background light
    Tft.TFTinit();  // init TFT library
    Tft.setDisplayDirect(RIGHT2LEFT);

    Serial.println(F("TFT LCD test"));
  pinMode(dirpin, OUTPUT);
  pinMode(steppin, OUTPUT);
  
  Tft.TFTinit(),  //test maart 2017
  //tft.reset();
  delay(500);
 uint16_t identifier = Tft.readID();

  InitialiseIO();
InitialiseInterrupt();

    identifier=0x9341;

    Tft.fillScreen(0, 240, 0, 260,MIDNIGHT_BLUE);
    
    
    // increase buttons and Right movement 
    Tft.drawCircle(30, 40, 25,WHITE);
    Tft.drawCircle(30, 100, 25,WHITE);
    Tft.drawCircle(30, 160, 25,WHITE);
    Tft.drawCircle(30, 220, 25,WHITE);
    Tft.drawString ("+",42,237,5,GREEN);
    Tft.drawString("+",42,177,5,GREEN );
    Tft.drawString("+",42,117,5,GREEN );
    Tft.drawString("R",42,57,5,GREEN );
     

    // Decrease buttons and Left movement
    Tft.drawCircle(210, 40, 25,WHITE);
    Tft.drawCircle(210, 100, 25,WHITE);
    Tft.drawCircle(210, 160, 25,WHITE);
    Tft.drawCircle(210, 220, 25,WHITE);
    Tft.drawString("-",222,237,5,RED );
    Tft.drawString("-",222,177,5,RED );
    Tft.drawString("-",222,117,5,RED );
    Tft.drawString("L",222,57,5,RED );

    //Data 
    Tft.fillRectangle(78, 240, 80,40,BLACK);
    Tft.fillRectangle(78, 180, 80,40,BLACK);
    Tft.fillRectangle(78, 120, 80,40,BLACK);
    Tft.fillRectangle(73, 60, 90,40,BLACK);
    Tft.drawRectangle(77, 200,82,42,ORANGE);
    Tft.drawRectangle(77, 140,82,42,ORANGE);
    Tft.drawRectangle(77, 80,82,42,ORANGE);
    Tft.drawRectangle(72, 20,92,42,ORANGE);
    
    //start/stop buttons
    Tft.fillRectangle(0, 320, 120,60,RED);
    Tft.drawRectangle(0, 260, 120,60,BLACK);    
    Tft.fillRectangle(120, 320, 120,60,GREEN);
    Tft.drawRectangle(120, 260, 120,60,BLACK);
//Text for the Start button
    Tft.drawString("START",235,297,3,BLACK );
//Text for the Stop button
    Tft.drawString("STOP",105,297,3,BLACK );

// Description text for Toggle buttons
    Tft.drawString("Time/Seconds",165,255,1,WHITE );
    Tft.drawString("Speed",135,195,1,WHITE );
    Tft.drawString("Lenght/Travel",170,135,1,WHITE );
    Tft.drawString("Direction",150,75,1,WHITE );
    Tft.drawString("Rev. 02 Made By R. Hoogmolen",230,8,1,BLACK );
  //-----------------------TEST
}
void takeReading()
{
  runstepper();
  digitalWrite(trig, HIGH);
    delay(1000);
    digitalWrite(trig, LOW);
    delay(1000);

}

void runstepper()
  {
    int i;
    digitalWrite(dirpin, stepdirection);     // Set the direction.
    
   
   for (i = 0; i<steplenght; i++)       // Iterate for 4000 microsteps.
  {
    if(runok)
    {
    digitalWrite(steppin, LOW);  // This LOW to HIGH change is what creates the
    delayMicroseconds(steplenght);
    digitalWrite(steppin, HIGH); // "Rising Edge" so the easydriver knows to when to step.
    delayMicroseconds(stepspeed); // This delay time is close to top speed for this
    
    }
  }
  }



void stopall()
{
  t.stop(eventid);
  Tft.drawString("STOP",105,297,3,YELLOW);
  delay(3000);
  Tft.drawString("STOP",105,297,3,BLACK);
}

void InitialiseIO(){

  pinMode(A5, INPUT);    // Pin A2 is input to which a switch is connected
  digitalWrite(A5, HIGH);   // Configure internal pull-up resistor
}

void InitialiseInterrupt(){
  cli();    // switch interrupts off while messing with their settings  
  PCICR =0x02;          // Enable PCINT1 interrupt
  PCMSK1 = 0b00100000;
  sei();    // turn interrupts back on
}

ISR(PCINT1_vect) {    // Interrupt service routine. Every single PCINT8..14 (=ADC0..5) change
            // will generate an interrupt: but this will always be the same interrupt routine
  runok = false;
  if (digitalRead(A5)==0)  Serial.println("A5");
  stopall();
}

void loop() {
  // a point object holds x y and z coordinates
  Point p = ts.getPoint();

  if (p.z > __PRESURE) {
     Serial.print("Raw X = "); Serial.print(p.x);
     Serial.print("\tRaw Y = "); Serial.print(p.y);
     Serial.print("\tPressure = "); Serial.println(p.z);
     }
  
 int i;
  p.x = map(p.x, TS_MINX, TS_MAXX, 0, 240);
  p.y = map(p.y, TS_MINY, TS_MAXY, 0, 320);
  
  // we have some minimum pressure we consider 'valid'
  // pressure of 0 means no pressing!
  if (p.z > __PRESURE) {
     Serial.print("X = "); Serial.print(p.x);
     Serial.print("\tY = "); Serial.print(p.y);
     Serial.print("\tPressure = "); Serial.println(p.z);
  }

  delay(100);

t.update();
  pinMode(XP, OUTPUT);
  pinMode(XM, OUTPUT);
  pinMode(YP, OUTPUT);
  pinMode(YM, OUTPUT);

  // Start Button       
    if (p.y > 260 && p.y < 320 && p.x > 120 && p.x < 240) 
      {
        runok = true;
        Tft.drawString("START",235,297,3,RED);
         eventid = t.every(tid, takeReading);                     
        delay(3000);
        Tft.drawString("START",235,297,3,BLACK);
          
      }
// Stop Button       
    if (p.y > 260 && p.y < 320 && p.x > 0 && p.x < 120) 
      {
        Serial.print("STOP");
        stopall();
      
      }

 
 // Minus seconds Button       
    if (p.y > 190 && p.y < 250 && p.x > 190 && p.x < 240) 
      {
        Tft.fillRectangle(78, 240, 80,40,BLACK);
        Tft.drawString(itoa(tid/1000, buf, 10),130,230,2,WHITE );
        tid-=1000;
        Serial.println(tid);
        //delay(1000);
        
      }   

 // Plus seconds Button       
    if (p.y > 190 && p.y < 250 && p.x > 0 && p.x < 50) 
      {
        Tft.fillRectangle(78, 240, 80,40,BLACK);
        Tft.drawString (itoa(tid/1000, buf, 10),130,230,2,WHITE);
        tid+=1000;
        Serial.println(tid);
        //delay(1000);
        
      }   

// Minus speed button       
    if (p.y > 130 && p.y < 180 && p.x > 190 && p.x < 240) 
      {
        Tft.fillRectangle(78, 180, 80,40,BLACK);
        stepspeed-=100;
        Tft.drawString (itoa(stepspeed/100, buf, 10),130,170,2,WHITE);
        Serial.println(stepspeed);
        delay(250);
      }
      
    // Plus speed button       
    if (p.y > 130 && p.y < 180 && p.x > 0 && p.x < 50) 
      {
        Tft.fillRectangle(78, 180, 80,40,BLACK);
        stepspeed+=100;
        Tft.drawString (itoa(stepspeed/100, buf, 10),130,170,2,WHITE);
        Serial.println(stepspeed);
        delay(250);
      }

// minus Lenght  button       
    if (p.y > 70 && p.y < 120 && p.x > 190 && p.x < 240) 
      {
       Tft.fillRectangle(78, 120, 80,40,BLACK);
       steplenght-=100;
       Tft.drawString (itoa(steplenght/100, buf, 10),130,110,2,WHITE);
       Serial.println(steplenght);
       delay(250);
       
      }
      
    // Plus Lenght  Button       
    if (p.y > 70 && p.y < 120 && p.x > 0 && p.x < 50) 
      {
       Tft.fillRectangle(78, 120, 80,40,BLACK);
       steplenght+=100;
       Tft.drawString (itoa(steplenght/100, buf, 10),130,110,2,WHITE);
       Serial.println(steplenght);
       delay(250);
      }
 
 // Right Button        
    if (p.y > 10 && p.y < 60 && p.x > 0 && p.x < 50) 
      {
       Tft.fillRectangle(73, 60, 90,40,BLACK);
       Tft.drawString("RIGHT",154,50,2,GREEN );
       stepdirection=HIGH;
       Serial.print("Right");
       Serial.print(stepdirection);
    
      }
    // Left Button       
    if (p.y > 10 && p.y < 60 && p.x > 190 && p.x < 240) 
      {
       Tft.fillRectangle(73, 60, 90,40,BLACK);
       Tft.drawString("LEFT",147,50,2,RED );
       stepdirection=LOW;
       Serial.print("Left");
       Serial.print(stepdirection);
      }
}





  






/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
